<?php
if(!defined('IN_MADISS')) die('Action impossible ! (erreur: Script could not be opened alone)'); //Vérifi si appeler par nos scripts
/*
	@! Utilisation de l'AutoUpdate
	@@ Mise à jour automatique ou installation d'une application web.
	@@ Version 1.4 (10/2015)
	--------------------------------------------------------------------
	** author: InternetBF
	** Site Web: internetbf.com
	** email: internetbf@gmail.com
	--------------------------------------------------------------------
	# Le système utilise 2 fonctions
	## CheckUpdate() : vérifie la présence de version(s) plus récente.
	## AutoUpdate() : vérifie la présence de version(s) plus récente ET procéde à l'intallation de la mise a jour si néccésaire.
	## Lors de la mise à jour si des fichiers n'existent pas ils sont créer, ce qui permet de détourner le système en installateur.
	## Lors de la mise à jour si le fichier "InstallUpDate.php" existe il sera exécuté.
	
	CheckUpdate(string server_url, string current_version)
	## server_url = adresse du serveur contenant la liste des versions
	## current_version = version actuelle de l'application
	
	AutoUpdate(string server_url, string current_version [, string install_dir = '../'])
	## server_url = adresse du serveur contenant la liste des versions
	## current_version = version actuelle de l'application
	## AutoUpdateDir = localisation du répertoire Temp de l'installation (optionnel, ./ par defaut)
	## install_dir = localisation du répertoire racine de l'installation (optionnel, ../ par defaut)
	--------------------------------------------------------------------
	@@ Package: AutoUpdate Functions
	@! Page: AutoUpdate.fct.php
*/
/*
format the time in seconds
*/

function CheckUpdate($server_url, $currentVersion){	
	$statut = array();
	$error = array();
	$_UPDATE = array();
	
	if(version_compare(phpversion(), 5.3, '<')){ $error[] = "Your version of php (".phpversion().") is lower than 5.3 !";goto endout;}
	
	//Start Check
	$statut[] = 'Start Checking for an update.';
	$statut[] = 'Curent version '.$currentVersion;
	$statut[] = 'Download version list.';
	//Check for an update. We have a simple file that has a new release version on each line. (1.00, 1.02, 1.03, etc.)
	// if(!is_file($server_url)){
		// $error[] = 'Can\'t find version list !';
		// goto endout;
	// }
	if(!$getVersions = @file_get_contents($server_url)){
		 $error[] = 'Can\'t download version list !';
		 goto endout;
	}
	
	$versionList = json_decode($getVersions, true);
	if (!is_array($versionList)) {
		$error[] ='Unable to parse json update file!';
		goto endout;
	}
	// Check for latest version
	foreach ($versionList as $versionRaw => $updateUrl) {
		if (version_compare($currentVersion, $versionRaw, '<')) {
			$_UPDATE = array("version" => $versionRaw, "infos" => $updateUrl);
			break;	// Arret à la premier version trouvé, pour passer directement à la dernière commenter cette ligne + la 108.
		}
	}
	if(empty($_UPDATE)){return false;}
	$statut[] = 'New version founded ! (V '.$_UPDATE['version'].')';
	// Preparing the output
	endout:
	$out = array("statut" => $statut,"error" => $error,"update" => $_UPDATE);
	// var_dump($out);
	return $out;
}

function AutoUpdate($server_url, $currentVersion, $AutoUpdateDir = './', $installDir = '../'){
	global $pdo;
	ini_set('max_execution_time',60);
	$statut = array();
	$error = array();
	// $_UPDATE = array();
	
	if(version_compare(phpversion(), 5.3, '<')){ $error[] = "Your version of php (".phpversion().") is lower than 5.3 !";goto endout;}
	
	//Start update
	$statut[] = 'Start Update';
	$statut[] = 'Curent version '.$currentVersion;
	$statut[] = 'Download version list';
	//Check for an update. We have a simple file that has a new release version on each line. (1.00, 1.02, 1.03, etc.)
	// if(!is_file($server_url)){
		// $error[] = 'Can\'t find version list !';
		// goto endout;
	// }
	if(!$getVersions = @file_get_contents($server_url)){
		 $error[] = 'Can\'t download version list !';
		 goto endout;
	}
	
	$versionList = json_decode($getVersions, true);
	if (!is_array($versionList)) {
		$error[] ='Unable to parse json update file!';
		goto endout;
	}
	// Check for latest version
	foreach ($versionList as $versionRaw => $updateUrl) {
		if (version_compare($currentVersion, $versionRaw, '<')) {
			$_UPDATE = array("version" => $versionRaw, "infos" => $updateUrl);
			break;	// Arret à la premier version trouvé, pour passer directement à la dernière commenter cette ligne + la 64.
		}
	}
	if(empty($_UPDATE)){return false;} //UP TO DATE
	$statut[] = 'New version founded ! (V '.$_UPDATE['version'].')';
	//Downloading latest version
	$statut[] = 'Trying to download version '.$_UPDATE['version'].'';
	$statut[] = 'Infos: '.$_UPDATE['infos']['description'].'';
	$newVersions = @file_get_contents($_UPDATE['infos']['url']);
	if(empty($newVersions) or $newVersions == false){
		$error[] = 'Can\'t download version '.$_UPDATE['version'].' !';
		goto endout;
	}
	$handle = fopen($AutoUpdateDir.'/temp/'.$_UPDATE['version'].'.zip', 'w');
	if (!$handle) {
		$error[] ='Could not open file handle to save update !';
		goto endout;
	}
	if (!fwrite($handle, $newVersions)) {
		fclose($handle);
		$error[] ='Could not write update to file !';
		goto endout;
	}
	fclose($handle);
	$statut[] = 'Version '.$_UPDATE['version'].' downloaded';
	
	restart:
	
	$statut[] = 'Starting files update ...';
	// Check if zip file could be opened
	$zip = zip_open($AutoUpdateDir.'/temp/'.$_UPDATE['version'].'.zip');
	if (!is_resource($zip)) {
		$error[] ='Could not open zip file, error: '.$zip.' !';
		goto endout;
	}
	// Read every file from archive
	while ($file = zip_read($zip)) {
		$filename = zip_entry_name($file);
		$foldername = $installDir . dirname($filename);
		$absoluteFilename = $installDir . $filename;
		$statut[] = 'Updating file '.$filename.'.';
		if (!is_dir($foldername)) {
			if (!@mkdir($foldername, 0777, true)) {
				if($startry != 1){
					$startry = 1;
					$statut[] = 'Parent directory ('.$installDir.') of '.$filename.' is not writeable !<br> Trying to install again.';
					goto restart;
				}else{
					$error[] ='Parent directory ('.$installDir.') of '.$filename.' has to be writeable !<br> Refresh the page to try again.';
					goto endout;
				}
			}
		}
		// Skip if entry is a directory
		if (substr($filename, -1, 1) == '/')
			continue;
		// Read file contents from archive
		$contents = zip_entry_read($file, zip_entry_filesize($file));
		if ($contents === false) {
			$this->_log->addError(sprintf('Coud not read zip entry "%s"', $file));
			$error[] ='Coud not read zip entry '.$file.' ...';
			continue;
		}
		// Write to file
		if (file_exists($absoluteFilename)) {
			if (!is_writable($absoluteFilename)) {
				zip_close($zip);
				$error[] ='Could not overwrite '.$absoluteFilename.' !';
				goto endout;
			}
		} else {
			if (!touch($absoluteFilename)) {
				zip_close($zip);
				$error[] ='The file '.$absoluteFilename.' could not be created !';
				goto endout;
			}
			$statut[] = 'File '.$absoluteFilename.' created';
		}
		$updateHandle = @fopen($absoluteFilename, 'w');
		if (!$updateHandle) {
			zip_close($zip);
			$error[] ='Could not open file '.$absoluteFilename.' !';
			goto endout;
		}
		if (!fwrite($updateHandle, $contents)) {
			zip_close($zip);
			$error[] ='Could not write to file '.$absoluteFilename.' !';
			goto endout;
		}
		fclose($updateHandle);
		// ||| If file is a update script, include ! |||
		if ($filename == 'InstallUpDate.php') {
			$statut[] = 'Try to include update script '.$absoluteFilename.'';
			require($absoluteFilename);
			$statut[] = 'Update script '.$absoluteFilename.' included';
			if (!unlink($absoluteFilename)) {
				$error[] ='Could not delete update file '.$absoluteFilename.' !';
			}
		}
	}
	zip_close($zip);
	$statut[] = 'Delete TEMP files';
	$statut[] = 'Version '.$_UPDATE['version'].' installed successfully !';
	if (!unlink($AutoUpdateDir.'/temp/'.$_UPDATE['version'].'.zip')) {
		$error[] ='Could not delete update ZIP '.$_UPDATE['version'].'.zip !';
	}
	
	// Preparing the output
	endout:
	$out = array("statut" => $statut,"error" => $error,"update" => $_UPDATE);
	// var_dump($out);
	return $out;
}

?>